
// DatePicker Menu
var calToolbarDateMenu = new Ext.menu.DateMenu({
    handler : function(dp, date){
    	dp.setValue(date);
    	changeView(cal_actual_view, date.format('d'), date.format('n'), date.format('Y'), actual_user_filter, actual_state_filter);
    }
});

Ext.apply(calToolbarDateMenu.picker, { 
	okText: lang('ok'),
	cancelText: lang('cancel'),
	monthNames: [lang('month 1'), lang('month 2'), lang('month 3'), lang('month 4'), lang('month 5'), lang('month 6'), lang('month 7'), lang('month 8'), lang('month 9'), lang('month 10'), lang('month 11'), lang('month 12')],
	dayNames:[lang('sunday'), lang('monday'), lang('tuesday'), lang('wednesday'), lang('thursday'), lang('friday'), lang('saturday')],
	monthYearText: '',
	nextText: lang('next month'),
	prevText: lang('prev month'),
	todayText: lang('today'),
	todayTip: lang('today')
});

// Actual view
var cal_actual_view = 'viewweek';
// Actual user filter
var actual_user_filter = '0'; // 0=logged user, -1=all users
// Actual state filter
var actual_state_filter = ' 0 1 3'; // -1=all states

var executing_my_calendar = false; //flag to avoid handler calls when changing the values of checks

function changeView(action, day, month, year, u_filter, s_filter) {
	var url = og.getUrl('event', action, {
		day: day,
		month: month,
		year: year,
		user_filter: u_filter,
		state_filter: s_filter
	});
	og.openLink(url, null);
}


function addStateFilter(filter) {
	actual_state_filter += ' ' + filter;
}

function removeStateFilter(filter) {
	actual_state_filter = actual_state_filter.replace('/-1/', '');
	actual_state_filter = actual_state_filter.replace(' ' + filter, '');
}

// Filter by Invitation State
viewActionsState = {
	all: new Ext.Action({
		text: lang('view all'),
		handler: function() {
			actual_state_filter = -1;
			var date = calToolbarDateMenu.picker.getValue();
			changeView(cal_actual_view, date.getDate(), date.getMonth() + 1, date.getFullYear(), actual_user_filter, actual_state_filter);
		}
	}),
	pending: {
		//iconCls: 'ico-mail-mark-unread',
		id: 'check_inv_pending',
        text: lang('view pending response'),
		checked: true,
		checkHandler: function() {
			if (!executing_my_calendar) {
				if (this.checked) addStateFilter('0');
				else removeStateFilter('0');
				var date = calToolbarDateMenu.picker.getValue();
				changeView(cal_actual_view, date.getDate(), date.getMonth() + 1, date.getFullYear(), actual_user_filter, actual_state_filter);
			}
		}
	},
	yes: {
		//iconCls: 'ico-complete',
        id: 'check_inv_yes',
        text: lang('view will attend'),
		checked: true,
		checkHandler: function() {
			if (!executing_my_calendar) {
				if (this.checked) addStateFilter('1');
				else removeStateFilter('1');
				var date = calToolbarDateMenu.picker.getValue();
				changeView(cal_actual_view, date.getDate(), date.getMonth() + 1, date.getFullYear(), actual_user_filter, actual_state_filter);
			}
		}
	},
	no: {
		//iconCls: 'ico-delete',
        id: 'check_inv_no',
        text: lang('view will not attend'),
		checked: false,
		checkHandler: function() {
			if (!executing_my_calendar) {
				if (this.checked) addStateFilter('2');
				else removeStateFilter('2');
				var date = calToolbarDateMenu.picker.getValue();
				changeView(cal_actual_view, date.getDate(), date.getMonth() + 1, date.getFullYear(), actual_user_filter, actual_state_filter);
			}
		}
	},
	maybe: {
		//iconCls: 'ico-help',
        id: 'check_inv_maybe',
        text: lang('view maybe attend'),
		checked: true,
		checkHandler: function() {
			if (!executing_my_calendar) {
				if (this.checked) addStateFilter('3');
				else removeStateFilter('3');
				var date = calToolbarDateMenu.picker.getValue();
				changeView(cal_actual_view, date.getDate(), date.getMonth() + 1, date.getFullYear(), actual_user_filter, actual_state_filter);
			}
		}
	}
};

// Toolbar
og.CalendarToolbarItems = [ 
	new Ext.Action({
		text: lang('add event'),
        tooltip: lang('add new event'),
        iconCls: 'ico-new',
        handler: function() {
        	var date = calToolbarDateMenu.picker.getValue();
        	hideCalendarToolbar();
			changeView('add', date.getDate(), date.getMonth() + 1, date.getFullYear(), actual_user_filter, actual_state_filter);
		}
	}),
	'-',
	new Ext.Action({
		text: lang('month'),
        tooltip: lang('month view'),
        iconCls: 'ico-calendar-month',
        handler: function() {
        	cal_actual_view = 'index';
			var date = calToolbarDateMenu.picker.getValue();
			changeView(cal_actual_view, date.getDate(), date.getMonth() + 1, date.getFullYear(), actual_user_filter, actual_state_filter);
		}
	}),
	new Ext.Action({
		text: lang('week'),
        tooltip: lang('week view'),
        iconCls: 'ico-calendar-week',
        handler: function() {
			cal_actual_view = 'viewweek';
			var date = calToolbarDateMenu.picker.getValue();
			changeView(cal_actual_view, date.getDate(), date.getMonth() + 1, date.getFullYear(), actual_user_filter, actual_state_filter);
		}
	}),
	new Ext.Action({
		text: lang('day'),
        tooltip: lang('day view'),
        iconCls: 'ico-today',
        handler: function() {
			cal_actual_view = 'viewdate';
			var date = calToolbarDateMenu.picker.getValue();
			changeView(cal_actual_view, date.getDate(), date.getMonth() + 1, date.getFullYear(), actual_user_filter, actual_state_filter);
		}
	}),
	'-',
	new Ext.Action({
		tooltip: lang('prev'),
        iconCls: 'ico-prevmonth',
        handler: function() {
        	var date = calToolbarDateMenu.picker.getValue();
        	if (cal_actual_view == 'index') date = date.add(Date.MONTH, -1);
        	if (cal_actual_view == 'viewweek') date = date.add(Date.DAY, -7);
        	if (cal_actual_view == 'viewdate') date = date.add(Date.DAY, -1);
        	calToolbarDateMenu.picker.setValue(date);
			
			changeView(cal_actual_view, date.getDate(), date.getMonth() + 1, date.getFullYear(), actual_user_filter, actual_state_filter);
		}
	}),
	new Ext.Action({
		tooltip: lang('next'),
        iconCls: 'ico-nextmonth',
        handler: function() {
        	var date = calToolbarDateMenu.picker.getValue();
        	if (cal_actual_view == 'index') date = date.add(Date.MONTH, 1);
        	if (cal_actual_view == 'viewweek') date = date.add(Date.DAY, 7);
        	if (cal_actual_view == 'viewdate') date = date.add(Date.DAY, 1);
        	calToolbarDateMenu.picker.setValue(date);
			
			changeView(cal_actual_view, date.getDate(), date.getMonth() + 1, date.getFullYear(), actual_user_filter, actual_state_filter);
		}
	}),
	'-',
	new Ext.Action({
		text: lang('pick a date'),
        tooltip: lang('pick a date'),
        menu: calToolbarDateMenu
	}),
	'-',
	new Ext.Action({
		text: lang('view'),
        iconCls: 'op-ico-view',
        menu: {items: [
        	new Ext.Action({
				text: lang('my calendar'),
		        iconCls: 'ico-calendar',
		        handler: function() {
					actual_user_filter = 0;
					actual_state_filter = ' 0 1 3';
					executing_my_calendar = true; //disable handler executions
					Ext.getCmp('check_inv_pending').setChecked(true);
					Ext.getCmp('check_inv_yes').setChecked(true);
					Ext.getCmp('check_inv_no').setChecked(false);
					Ext.getCmp('check_inv_maybe').setChecked(true);
					executing_my_calendar = false; //enable handler executions 
					var date = calToolbarDateMenu.picker.getValue();
					changeView(cal_actual_view, date.getDate(), date.getMonth() + 1, date.getFullYear(), actual_user_filter, actual_state_filter);
				}
			}),
			'-',
        	new Ext.Action({
	        	iconCls: 'op-ico-details',
				text: lang('by state'),
				menu: {items: [
					viewActionsState.pending,
					viewActionsState.yes,
					viewActionsState.no,
					viewActionsState.maybe
				]}
			}),
			new Ext.Action({
				text: lang('by user'),
	            iconCls: 'ico-user',
				menu: new og.UserMenu({
					listeners: {
						'userselect': {
							fn: function(userid) {
								actual_user_filter = userid;
								var date = calToolbarDateMenu.picker.getValue();
								changeView(cal_actual_view, date.getDate(), date.getMonth() + 1, date.getFullYear(), actual_user_filter, actual_state_filter);
							},
							scope: this
						}
					}
				})
			})
		]}
	}),
	'-',
	new Ext.Action({
		text: lang('import/export'),
           tooltip: lang('import - export'),
		menu: {items: [
			{text: lang('import'), iconCls: 'ico-upload', handler: function() {
				hideCalendarToolbar();
				var url = og.getUrl('event', 'icalendar_import');
				og.openLink(url);
			}},
			{text: lang('export'), iconCls: 'ico-download', handler: function() {
				hideCalendarToolbar();
				var url = og.getUrl('event', 'icalendar_export');
				og.openLink(url);
			}}
		]}
	})
	
];

